Index: palm/trunk/SOURCE/pmc_interface.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface.f90	(revision 1789)
+++ palm/trunk/SOURCE/pmc_interface.f90	(revision 1791)
@@ -3069,839 +3735,327 @@
 
 
-   SUBROUTINE pmci_extrap_ifoutflow_lr( f, kb, edge, var )
-
-!
-!--   After the interpolation of ghost-node values for the client-domain boundary
-!--   conditions, this subroutine checks if there is a local outflow through the 
-!--   boundary. In that case this subroutine overwrites the interpolated values 
-!--   by values extrapolated from the domain. This subroutine handles the left and 
-!--   right boundaries.
-!--   However, this operation is only needed in case of one-way coupling.
-!
-!--                                       Antti Hellsten 9.3.2015.
-!
-!--   Indexing in the principal direction (i) is changed. Now, the nest-boundary 
-!--   values are interpolated only into the first ghost-node layers on each later 
-!--   boundary. These values are then simply copied to the second ghost-node layer.
-!
-!--                                       Antti Hellsten 6.10.2015.
-!
-      IMPLICIT NONE
-      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) ::  f    !:
-      INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg), INTENT(IN)          ::  kb   !:
-
-      CHARACTER(LEN=1),INTENT(IN) ::  edge   !:
-      CHARACTER(LEN=1),INTENT(IN) ::  var    !:
-
-      INTEGER(iwp) ::  i     !:
-      INTEGER(iwp) ::  ib    !:
-      INTEGER(iwp) ::  ied   !:
-      INTEGER(iwp) ::  j     !:
-      INTEGER(iwp) ::  k     !:
+    SUBROUTINE pmci_extrap_ifoutflow_lr( f, kb, edge, var )
+!
+!--    After the interpolation of ghost-node values for the client-domain
+!--    boundary conditions, this subroutine checks if there is a local outflow
+!--    through the boundary. In that case this subroutine overwrites the
+!--    interpolated values by values extrapolated from the domain. This
+!--    subroutine handles the left and right boundaries. However, this operation
+!--    is only needed in case of one-way coupling.
+       IMPLICIT NONE
+
+       CHARACTER(LEN=1),INTENT(IN) ::  edge   !:
+       CHARACTER(LEN=1),INTENT(IN) ::  var    !:
+
+       INTEGER(iwp) ::  i     !:
+       INTEGER(iwp) ::  ib    !:
+       INTEGER(iwp) ::  ibgp  !:
+       INTEGER(iwp) ::  ied   !:
+       INTEGER(iwp) ::  j     !:
+       INTEGER(iwp) ::  k     !:
       
-      REAL(wp) ::  outnor    !:
-      REAL(wp) ::  vdotnor   !:
-
-!
-!--   Check which edge is to be handled: left or right. 
-      IF ( edge == 'l' )  THEN
-         IF ( var == 'u' )  THEN
-            i   = nxl
-            ib  = nxl - 1
-            ied = nxl + 1
-         ELSE
-            i   = nxl - 1
-            ib  = nxl - 2
-            ied = nxl
-         ENDIF
-         outnor = -1.0_wp
-      ELSEIF ( edge == 'r' )  THEN
-         i      = nxr + 1
-         ib     = nxr + 2
-         ied    = nxr
-         outnor = 1.0_wp
-      ENDIF
-
-      DO  j = nys, nyn + 1
-         DO  k = kb(j,i), nzt +1
-            vdotnor = outnor * u(k,j,ied)
-            IF ( vdotnor > 0.0_wp )  THEN   !  Local outflow.
-               f(k,j,i) = f(k,j,ied)
-            ENDIF
-         ENDDO
-         IF ( (var == 'u' )  .OR.  (var == 'v' )  .OR.  (var == 'w') )  THEN
-            f(kb(j,i),j,i) = 0.0_wp
-         ENDIF
-      ENDDO
-
-!
-!--   Store the updated boundary values also into the second ghost node layer.
-      f(0:nzt,nys:nyn+1,ib) = f(0:nzt,nys:nyn+1,i)
-
-   END SUBROUTINE pmci_extrap_ifoutflow_lr
-
-
-
-   SUBROUTINE pmci_extrap_ifoutflow_sn( f, kb, edge, var )
-!
-!--   After  the interpolation of ghost-node values for the client-domain boundary
-!--   conditions, this subroutine checks if there is a local outflow through the 
-!--   boundary. In that case this subroutine overwrites the interpolated values 
-!--   by values extrapolated from the domain. This subroutine handles the south and 
-!--   north boundaries. 
-!
-!--                                       Antti Hellsten 9.3.2015.
-!
-!--   Indexing in the principal direction (j) is changed. Now, the nest-boundary 
-!--   values are interpolated only into the first ghost-node layers on each later 
-!--   boundary. These values are then simply copied to the second ghost-node layer.
-!
-!--                                       Antti Hellsten 6.10.2015.
-
-      IMPLICIT NONE
-      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) ::  f    !:
-      INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg), INTENT(IN)          ::  kb   !:
-      CHARACTER(LEN=1), INTENT(IN) ::  edge   !:
-      CHARACTER(LEN=1), INTENT(IN) ::  var    !:
+       INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg), INTENT(IN) ::  kb   !:
+
+       REAL(wp) ::  outnor    !:
+       REAL(wp) ::  vdotnor   !:
+
+       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) :: f !:
+
+!
+!--    Check which edge is to be handled: left or right
+       IF ( edge == 'l' )  THEN
+          IF ( var == 'u' )  THEN
+             i   = nxl
+             ib  = nxl - 1
+             ied = nxl + 1
+          ELSE
+             i   = nxl - 1
+             ib  = nxl - 2
+             ied = nxl
+          ENDIF
+          outnor = -1.0_wp
+       ELSEIF ( edge == 'r' )  THEN
+          i      = nxr + 1
+          ib     = nxr + 2
+          ied    = nxr
+          outnor = 1.0_wp
+       ENDIF
+
+       DO  j = nys, nyn + 1
+          DO  k = kb(j,i), nzt +1
+             vdotnor = outnor * u(k,j,ied)
+!
+!--          Local outflow
+             IF ( vdotnor > 0.0_wp )  THEN
+                f(k,j,i) = f(k,j,ied)
+             ENDIF
+          ENDDO
+          IF ( (var == 'u' )  .OR.  (var == 'v' )  .OR.  (var == 'w') )  THEN
+             f(kb(j,i),j,i) = 0.0_wp
+          ENDIF
+       ENDDO
+
+!
+!--    Store the boundary values also into the redundant ghost node layers.
+       IF ( edge == 'l' )  THEN
+          DO ibgp = -nbgp, ib
+             f(0:nzt+1,nysg:nyng,ibgp) = f(0:nzt+1,nysg:nyng,i)
+          ENDDO
+       ELSEIF ( edge == 'r' )  THEN
+          DO ibgp = ib, nx + nbgp
+             f(0:nzt+1,nysg:nyng,ibgp) = f(0:nzt+1,nysg:nyng,i)
+          ENDDO
+       ENDIF
+
+    END SUBROUTINE pmci_extrap_ifoutflow_lr
+
+
+
+    SUBROUTINE pmci_extrap_ifoutflow_sn( f, kb, edge, var )
+!
+!--    After  the interpolation of ghost-node values for the client-domain
+!--    boundary conditions, this subroutine checks if there is a local outflow
+!--    through the boundary. In that case this subroutine overwrites the
+!--    interpolated values by values extrapolated from the domain. This
+!--    subroutine handles the south and north boundaries.
+       IMPLICIT NONE
+
+       CHARACTER(LEN=1), INTENT(IN) ::  edge   !:
+       CHARACTER(LEN=1), INTENT(IN) ::  var    !:
       
-      INTEGER(iwp) ::  i         !:
-      INTEGER(iwp) ::  j         !:
-      INTEGER(iwp) ::  jb        !:
-      INTEGER(iwp) ::  jed       !:
-      INTEGER(iwp) ::  k         !:
-      REAL(wp)     ::  outnor    !:
-      REAL(wp)     ::  vdotnor   !:
-
-!
-!--   Check which edge is to be handled: left or right. 
-      IF ( edge == 's' )  THEN
-         IF ( var == 'v' )  THEN
-            j   = nys
-            jb  = nys - 1
-            jed = nys + 1
-         ELSE
-            j   = nys - 1
-            jb  = nys - 2
-            jed = nys
-         ENDIF
-         outnor = -1.0_wp
-      ELSEIF ( edge == 'n' )  THEN
-         j      = nyn + 1
-         jb     = nyn + 2
-         jed    = nyn
-         outnor = 1.0_wp
-      ENDIF
-
-      DO  i = nxl, nxr + 1
-         DO  k = kb(j,i), nzt + 1
-            vdotnor = outnor * v(k,jed,i)
-            IF ( vdotnor > 0.0_wp )  THEN   !  Local outflow.
-               f(k,j,i) = f(k,jed,i)                 
-            ENDIF
-         ENDDO
-         IF ( (var == 'u' )  .OR.  (var == 'v' )  .OR.  (var == 'w') )  THEN
-            f(kb(j,i),j,i) = 0.0_wp
-         ENDIF
-      ENDDO
-
-!
-!--   Store the updated boundary values also into the second ghost node layer.
-      f(0:nzt,jb,nxl:nxr+1) = f(0:nzt,j,nxl:nxr+1)
-
-   END SUBROUTINE pmci_extrap_ifoutflow_sn
+       INTEGER(iwp) ::  i         !:
+       INTEGER(iwp) ::  j         !:
+       INTEGER(iwp) ::  jb        !:
+       INTEGER(iwp) ::  jbgp      !:
+       INTEGER(iwp) ::  jed       !:
+       INTEGER(iwp) ::  k         !:
+
+       INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg), INTENT(IN) ::  kb   !:
+
+       REAL(wp)     ::  outnor    !:
+       REAL(wp)     ::  vdotnor   !:
+
+       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) :: f !:
+
+!
+!--    Check which edge is to be handled: left or right
+       IF ( edge == 's' )  THEN
+          IF ( var == 'v' )  THEN
+             j   = nys
+             jb  = nys - 1
+             jed = nys + 1
+          ELSE
+             j   = nys - 1
+             jb  = nys - 2
+             jed = nys
+          ENDIF
+          outnor = -1.0_wp
+       ELSEIF ( edge == 'n' )  THEN
+          j      = nyn + 1
+          jb     = nyn + 2
+          jed    = nyn
+          outnor = 1.0_wp
+       ENDIF
+
+       DO  i = nxl, nxr + 1
+          DO  k = kb(j,i), nzt + 1
+             vdotnor = outnor * v(k,jed,i)
+!
+!--          Local outflow
+             IF ( vdotnor > 0.0_wp )  THEN
+                f(k,j,i) = f(k,jed,i)
+             ENDIF
+          ENDDO
+          IF ( (var == 'u' )  .OR.  (var == 'v' )  .OR.  (var == 'w') )  THEN
+             f(kb(j,i),j,i) = 0.0_wp
+          ENDIF
+       ENDDO
+
+!
+!--    Store the boundary values also into the redundant ghost node layers.
+       IF ( edge == 's' )  THEN
+          DO jbgp = -nbgp, jb
+             f(0:nzt+1,jbgp,nxlg:nxrg) = f(0:nzt+1,j,nxlg:nxrg)
+          ENDDO
+       ELSEIF ( edge == 'n' )  THEN
+          DO jbgp = jb, ny + nbgp
+             f(0:nzt+1,jbgp,nxlg:nxrg) = f(0:nzt+1,j,nxlg:nxrg)
+          ENDDO
+       ENDIF
+
+    END SUBROUTINE pmci_extrap_ifoutflow_sn
 
  
 
-   SUBROUTINE pmci_extrap_ifoutflow_t( f, var )
-
-!
-!--   Interpolation of ghost-node values used as the client-domain boundary
-!--   conditions. This subroutine handles the top boundary. 
-!--   This subroutine is based on trilinear interpolation.
-!     
-!--                                       Antti Hellsten 23.2.2015.
-!     
-!     
-!--   Rewritten so that all the coefficients and client-array indices are 
-!--   precomputed in the initialization phase by init_interp_tril.
-!     
-!--                                       Antti Hellsten 3.3.2015. 
-!     
-!--   Indexing in the principal direction (k) is changed. Now, the nest-boundary 
-!--   values are extrapolated only into the first ghost-node layer. Actually there is 
-!--   only one ghost-node layer in the k-direction.  
-!     
-!--                                       Antti Hellsten 6.10.2015.
-      IMPLICIT NONE
-      REAL(wp), DIMENSION(nzb:nzt+1,nys-nbgp:nyn+nbgp,nxl-nbgp:nxr+nbgp), INTENT(INOUT) ::  f   !:
-      CHARACTER(LEN=1), INTENT(IN) ::  var   !:
+    SUBROUTINE pmci_extrap_ifoutflow_t( f, var )
+!
+!--    Interpolation of ghost-node values used as the client-domain boundary
+!--    conditions. This subroutine handles the top boundary. It is based on
+!--    trilinear interpolation.
+       IMPLICIT NONE
+
+       CHARACTER(LEN=1), INTENT(IN) ::  var   !:
       
-      INTEGER(iwp) ::  i     !:
-      INTEGER(iwp) ::  j     !:
-      INTEGER(iwp) ::  k     !:
-      INTEGER(iwp) ::  ked   !:
-      REAL(wp) ::  vdotnor   !:
+       INTEGER(iwp) ::  i     !:
+       INTEGER(iwp) ::  j     !:
+       INTEGER(iwp) ::  k     !:
+       INTEGER(iwp) ::  ked   !:
+
+       REAL(wp) ::  vdotnor   !:
+
+       REAL(wp), DIMENSION(nzb:nzt+1,nys-nbgp:nyn+nbgp,nxl-nbgp:nxr+nbgp),     &
+                 INTENT(INOUT) ::  f   !:
      
 
-      IF ( var == 'w' )  THEN
-         k    = nzt
-         ked  = nzt - 1
-      ELSE
-         k    = nzt + 1  
-         ked  = nzt
-      ENDIF
-
-      DO  i = nxl, nxr
-         DO  j = nys, nyn
-            vdotnor = w(ked,j,i)
-            IF ( vdotnor > 0.0_wp )  THEN   !:  Local outflow.              
-               f(k,j,i) = f(ked,j,i)
-            ENDIF
-         ENDDO
-      ENDDO
-
-!
-!--   Just fill up the second ghost-node layer for w.
-      IF ( var == 'w' )  THEN
-         f(nzt+1,:,:) = f(nzt,:,:)
-      ENDIF
-
-   END SUBROUTINE pmci_extrap_ifoutflow_t
-
-
-
-   SUBROUTINE pmci_anterp_tophat( f, fc, kce, ifl, ifu, jfl, jfu, kfl, kfu, kb, var )
-!
-!--   Anterpolation of internal-node values to be used as the server-domain 
-!--   values. This subroutine is based on the first-order numerical 
-!--   integration of the fine-grid values contained within the coarse-grid
-!--   cell. 
-!     
-!--                                        Antti Hellsten 16.9.2015.
-!
-      IMPLICIT NONE
-      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(IN)  ::  f     !:
-      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(INOUT)   ::  fc    !:
-      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN)                    ::  ifl   !:
-      INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN)                    ::  ifu   !:
-      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN)                    ::  jfl   !:
-      INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN)                    ::  jfu   !:
-      INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg), INTENT(IN)        ::  kb    !: may be unnecessary
-      INTEGER(iwp), INTENT(IN)                                        ::  kce   !:
-      INTEGER(iwp), DIMENSION(0:kce), INTENT(IN)                      ::  kfl   !:
-      INTEGER(iwp), DIMENSION(0:kce), INTENT(IN)                      ::  kfu   !:
-      CHARACTER(LEN=1), INTENT(IN)                                    ::  var   !:                            
-
-      INTEGER(iwp) ::  i         !:
-      INTEGER(iwp) ::  icb       !:
-      INTEGER(iwp) ::  ice       !:
-      INTEGER(iwp) ::  ifc       !:
-      INTEGER(iwp) ::  ijfc      !:
-      INTEGER(iwp) ::  j         !:
-      INTEGER(iwp) ::  jcb       !:
-      INTEGER(iwp) ::  jce       !:
-      INTEGER(iwp) ::  k         !:
-      INTEGER(iwp) ::  kcb       !:
-      INTEGER(iwp) ::  l         !:
-      INTEGER(iwp) ::  m         !:
-      INTEGER(iwp) ::  n         !:
-      INTEGER(iwp) ::  nfc       !:
-      REAL(wp)     ::  cellsum   !:
-      REAL(wp)     ::  f1f       !:
-      REAL(wp)     ::  fra       !:
+       IF ( var == 'w' )  THEN
+          k    = nzt
+          ked  = nzt - 1
+       ELSE
+          k    = nzt + 1
+          ked  = nzt
+       ENDIF
+
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             vdotnor = w(ked,j,i)
+!
+!--          Local outflow
+             IF ( vdotnor > 0.0_wp )  THEN
+                f(k,j,i) = f(ked,j,i)
+             ENDIF
+          ENDDO
+       ENDDO
+
+!
+!--    Just fill up the second ghost-node layer for w
+       IF ( var == 'w' )  THEN
+          f(nzt+1,:,:) = f(nzt,:,:)
+       ENDIF
+
+    END SUBROUTINE pmci_extrap_ifoutflow_t
+
+
+
+    SUBROUTINE pmci_anterp_tophat( f, fc, kct, ifl, ifu, jfl, jfu, kfl, kfu,   &
+                                   kb, var )
+!
+!--    Anterpolation of internal-node values to be used as the server-domain
+!--    values. This subroutine is based on the first-order numerical
+!--    integration of the fine-grid values contained within the coarse-grid
+!--    cell.
+       IMPLICIT NONE
+
+       CHARACTER(LEN=1), INTENT(IN) ::  var   !:
+
+       INTEGER(iwp) ::  i         !: Fine-grid index
+       INTEGER(iwp) ::  ii        !: Coarse-grid index
+       INTEGER(iwp) ::  iclp      !:
+       INTEGER(iwp) ::  icrm      !:
+       INTEGER(iwp) ::  ifc       !:
+       INTEGER(iwp) ::  ijfc      !:
+       INTEGER(iwp) ::  j         !: Fine-grid index
+       INTEGER(iwp) ::  jj        !: Coarse-grid index
+       INTEGER(iwp) ::  jcnm      !:
+       INTEGER(iwp) ::  jcsp      !:
+       INTEGER(iwp) ::  k         !: Fine-grid index
+       INTEGER(iwp) ::  kk        !: Coarse-grid index
+       INTEGER(iwp) ::  kcb       !:
+       INTEGER(iwp) ::  nfc       !:
+
+       INTEGER(iwp), INTENT(IN) ::  kct   !:
+
+       INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN)             ::  ifl   !:
+       INTEGER(iwp), DIMENSION(icl:icr), INTENT(IN)             ::  ifu   !:
+       INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN)             ::  jfl   !:
+       INTEGER(iwp), DIMENSION(jcs:jcn), INTENT(IN)             ::  jfu   !:
+!--    TO_DO: is the next line really unnecessary?
+       INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg), INTENT(IN) ::  kb    !: may be unnecessary
+       INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)               ::  kfl   !:
+       INTEGER(iwp), DIMENSION(0:kct), INTENT(IN)               ::  kfu   !:
+
+
+       REAL(wp) ::  cellsum   !:
+       REAL(wp) ::  f1f       !:
+       REAL(wp) ::  fra       !:
+
+       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(IN) ::  f   !:
+       REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(INOUT)  ::  fc  !:
   
 
-      icb = icl 
-      ice = icr 
-      jcb = jcs 
-      jce = jcn 
-
-!
-!--   Define the index bounds icb, ice, jcb and jce. 
-!--   Note that kcb is simply zero and kce enters here as a parameter and it is 
-!--   determined in init_anterp_tophat  
-      IF ( nest_bound_l )  THEN
-         IF ( var == 'u' )  THEN
-            icb = icl + nhll + 1
-         ELSE
-            icb = icl + nhll
-         ENDIF
-      ENDIF
-      IF ( nest_bound_r )  THEN
-         ice = icr - nhlr
-      ENDIF
-
-      IF ( nest_bound_s )  THEN
-         IF ( var == 'v' )  THEN
-            jcb = jcs + nhls + 1
-         ELSE
-            jcb = jcs + nhls
-         ENDIF
-      ENDIF
-      IF ( nest_bound_n )  THEN
-         jce = jcn - nhln
-      ENDIF
-      kcb = 0 
-
-!
-!--   Note that l,m, and n are coarse-grid indices and i,j, and k are fine-grid indices.
-      DO  l = icb, ice
-         ifc = ifu(l) - ifl(l) + 1
-         DO  m = jcb, jce
-            ijfc = ifc * ( jfu(m) - jfl(m) +1 )
-
-!
-!--         How to deal with the lower bound of k in case of non-flat topography?
-            !kcb = MIN( kb(jfl(m),ifl(l)), kb(jfu(m),ifl(l)), kb(jfl(m),ifu(l)), kb(jfu(m),ifu(l)) ) ! Something wrong with this.
-            DO  n = kcb, kce
-               nfc =  ijfc * ( kfu(n) - kfl(n) + 1 )
-               cellsum = 0.0
-               DO  i = ifl(l), ifu(l)
-                  DO  j = jfl(m), jfu(m)
-                     DO  k = kfl(n), kfu(n)
-                        cellsum = cellsum + f(k,j,i)
-                     ENDDO
-                  ENDDO
-               ENDDO
-
-!
-!--            Spatial under-relaxation.
-               fra  = frax(l) * fray(m) * fraz(n)
-!--            TO_DO: why not KIND=wp ?
-               fc(n,m,l) = ( 1.0_wp - fra ) * fc(n,m,l) + fra * cellsum / REAL( nfc, KIND=KIND(cellsum) )  
-            ENDDO
-         ENDDO
-      ENDDO
-
-   END SUBROUTINE pmci_anterp_tophat
+!
+!--    Initialize the index bounds for anterpolation 
+       iclp = icl 
+       icrm = icr 
+       jcsp = jcs 
+       jcnm = jcn 
+
+!
+!--    Define the index bounds iclp, icrm, jcsp and jcnm.
+!--    Note that kcb is simply zero and kct enters here as a parameter and it is
+!--    determined in pmci_init_anterp_tophat
+       IF ( nest_bound_l )  THEN
+          IF ( var == 'u' )  THEN
+             iclp = icl + nhll + 1
+          ELSE
+             iclp = icl + nhll
+          ENDIF
+       ENDIF
+       IF ( nest_bound_r )  THEN
+          icrm = icr - nhlr
+       ENDIF
+
+       IF ( nest_bound_s )  THEN
+          IF ( var == 'v' )  THEN
+             jcsp = jcs + nhls + 1
+          ELSE
+             jcsp = jcs + nhls
+          ENDIF
+       ENDIF
+       IF ( nest_bound_n )  THEN
+          jcnm = jcn - nhln
+       ENDIF
+       kcb = 0
+
+!
+!--    Note that l,m, and n are coarse-grid indices and i,j, and k are fine-grid
+!--    indices.
+       DO  ii = iclp, icrm
+          ifc = ifu(ii) - ifl(ii) + 1
+          DO  jj = jcsp, jcnm
+             ijfc = ifc * ( jfu(jj) - jfl(jj) + 1 )
+!
+!--          For simplicity anterpolate within buildings too
+             DO  kk = kcb, kct
+                nfc =  ijfc * ( kfu(kk) - kfl(kk) + 1 )
+                cellsum = 0.0_wp
+                DO  i = ifl(ii), ifu(ii)
+                   DO  j = jfl(jj), jfu(jj)
+                      DO  k = kfl(kk), kfu(kk)
+                         cellsum = cellsum + f(k,j,i)
+                      ENDDO
+                   ENDDO
+                ENDDO
+!
+!--             Spatial under-relaxation.
+                fra  = frax(ii) * fray(jj) * fraz(kk)
+!
+!--             Block out the fine-grid corner patches from the anterpolation
+                IF ( ( ifl(ii) < nxl ) .OR. ( ifu(ii) > nxr ) )  THEN
+                   IF ( ( jfl(jj) < nys ) .OR. ( jfu(jj) > nyn ) )  THEN
+                      fra = 0.0_wp
+                   ENDIF
+                ENDIF
+
+                fc(kk,jj,ii) = ( 1.0_wp - fra ) * fc(kk,jj,ii) +                 &
+                               fra * cellsum / REAL( nfc, KIND = wp )
+
+             ENDDO
+          ENDDO
+       ENDDO
+
+    END SUBROUTINE pmci_anterp_tophat
 
 #endif
  END SUBROUTINE pmci_client_datatrans
 
-
-
- SUBROUTINE pmci_update_new
-
-#if defined( __parallel )
-!
-!-- Copy the interpolated/anterpolated boundary values to the _p 
-!-- arrays, too, to make sure the interpolated/anterpolated boundary
-!-- values are carried over from one RK inner step to another.
-!-- So far works only with the cpp-switch __nopointer.
-!
-!--                 Antti Hellsten 8.3.2015 
-!
-
-!-- Just debugging
-    w(nzt+1,:,:) = w(nzt,:,:)
-
-    u_p  = u
-    v_p  = v
-    w_p  = w
-    e_p  = e
-    pt_p = pt
-    IF ( humidity  .OR.  passive_scalar )  THEN
-       q_p = q
-    ENDIF
-
-!
-!-- TO_DO: Find out later if nesting would work without __nopointer.
-#endif
-
- END SUBROUTINE pmci_update_new
-
-
-
- SUBROUTINE pmci_set_array_pointer( name, client_id, nz_cl )
-
-    IMPLICIT NONE
-
-    INTEGER, INTENT(IN)                  ::  client_id   !:
-    INTEGER, INTENT(IN)                  ::  nz_cl       !:
-    CHARACTER(LEN=*), INTENT(IN)         ::  name        !:
-    
-#if defined( __parallel )
-    REAL(wp), POINTER, DIMENSION(:,:)    ::  p_2d        !:
-    REAL(wp), POINTER, DIMENSION(:,:)    ::  p_2d_sec    !:
-    REAL(wp), POINTER, DIMENSION(:,:,:)  ::  p_3d        !:
-    REAL(wp), POINTER, DIMENSION(:,:,:)  ::  p_3d_sec    !:
-    INTEGER(iwp)                         ::  ierr        !:
-    INTEGER(iwp)                         ::  istat       !:
-    
-
-    NULLIFY( p_3d )
-    NULLIFY( p_2d )
-
-!
-!-- List of array names, which can be coupled
-!-- In case of 3D please change also the second array for the pointer version
-    IF ( TRIM(name) == "u" )     p_3d => u
-    IF ( TRIM(name) == "v" )     p_3d => v
-    IF ( TRIM(name) == "w" )     p_3d => w
-    IF ( TRIM(name) == "e" )     p_3d => e
-    IF ( TRIM(name) == "pt" )    p_3d => pt
-    IF ( TRIM(name) == "q" )     p_3d => q
-!
-!-- This is just an example for a 2D array, not active for coupling
-!-- Please note, that z0 has to be declared as TARGET array in modules.f90
-!    IF ( TRIM(name) == "z0" )    p_2d => z0
-
-#if defined( __nopointer )
-    IF ( ASSOCIATED( p_3d ) )  THEN
-       CALL pmc_s_set_dataarray( client_id, p_3d, nz_cl, nz )
-    ELSEIF ( ASSOCIATED( p_2d ) )  THEN
-       CALL pmc_s_set_dataarray( client_id, p_2d )
-    ELSE
-!
-!--    Give only one message for the root domain
-       IF ( myid == 0  .AND.  cpl_id == 1 )  THEN
-
-          message_string = 'pointer for array "' // TRIM( name ) //            &
-                           '" can''t be associated'
-          CALL message( 'pmci_set_array_pointer', 'PA0117', 3, 2, 0, 6, 0 )
-       ELSE
-!
-!--       Avoid others to continue
-          CALL MPI_BARRIER( comm2d, ierr )
-       ENDIF
-    ENDIF
-#else
-!-- TO_DO: Why aren't the other pointers (p_3d) not set to u_1, v_1, etc.??
-    IF ( TRIM(name) == "u" )     p_3d_sec => u_2
-    IF ( TRIM(name) == "v" )     p_3d_sec => v_2
-    IF ( TRIM(name) == "w" )     p_3d_sec => w_2
-    IF ( TRIM(name) == "e" )     p_3d_sec => e_2
-    IF ( TRIM(name) == "pt" )    p_3d_sec => pt_2
-    IF ( TRIM(name) == "q" )     p_3d_sec => q_2
-
-    IF ( ASSOCIATED( p_3d ) )  THEN
-       CALL pmc_s_set_dataarray( client_id, p_3d, nz_cl, nz, &
-                                 array_2 = p_3d_sec )
-    ELSEIF ( ASSOCIATED( p_2d ) )  THEN
-       CALL pmc_s_set_dataarray( client_id, p_2d )
-    ELSE
-!
-!--    Give only one message for the root domain
-       IF ( myid == 0  .AND.  cpl_id == 1 )  THEN
-
-          message_string = 'pointer for array "' // TRIM( name ) //            &
-                           '" can''t be associated'
-          CALL message( 'pmci_set_array_pointer', 'PA0117', 3, 2, 0, 6, 0 )
-       ELSE
-!
-!--       Avoid others to continue
-          CALL MPI_BARRIER( comm2d, ierr )
-       ENDIF
-
-   ENDIF
-#endif
-
-#endif
- END SUBROUTINE pmci_set_array_pointer
-
-
-
- SUBROUTINE pmci_create_client_arrays( name, is, ie, js, je, nzc  )
-
-    IMPLICIT NONE
-
-    INTEGER(iwp), INTENT(IN)              ::  ie      !:
-    INTEGER(iwp), INTENT(IN)              ::  is      !:
-    INTEGER(iwp), INTENT(IN)              ::  je      !:
-    INTEGER(iwp), INTENT(IN)              ::  js      !:
-    INTEGER(iwp), INTENT(IN)              ::  nzc     !:  Note that nzc is cg%nz
-    CHARACTER(LEN=*), INTENT(IN)          ::  name    !:
-     
-#if defined( __parallel )
-    REAL(wp), POINTER,DIMENSION(:,:)      ::  p_2d    !:
-    REAL(wp), POINTER,DIMENSION(:,:,:)    ::  p_3d    !:
-    INTEGER(iwp)                          ::  ierr    !:
-    INTEGER(iwp)                          ::  istat   !:
-
-
-    NULLIFY( p_3d )
-    NULLIFY( p_2d )
-
-!
-!-- List of array names, which can be coupled.
-!-- AH: Note that the k-range of the *c arrays is changed from 1:nz to 0:nz+1.
-    IF ( TRIM( name ) == "u" )  THEN
-       IF ( .NOT. ALLOCATED( uc ) )  ALLOCATE( uc(0:nzc+1, js:je, is:ie) )
-       p_3d => uc
-    ELSEIF ( TRIM( name ) == "v" )  THEN
-       IF ( .NOT. ALLOCATED( vc ) )  ALLOCATE( vc(0:nzc+1, js:je, is:ie) )
-       p_3d => vc
-    ELSEIF ( TRIM( name ) == "w" )  THEN
-       IF ( .NOT. ALLOCATED( wc ) )  ALLOCATE( wc(0:nzc+1, js:je, is:ie) )
-       p_3d => wc
-    ELSEIF ( TRIM( name ) == "e" )  THEN
-       IF ( .NOT. ALLOCATED( ec ) )  ALLOCATE( ec(0:nzc+1, js:je, is:ie) )
-       p_3d => ec
-    ELSEIF ( TRIM( name ) == "pt")  THEN
-       IF ( .NOT. ALLOCATED( ptc ) ) ALLOCATE( ptc(0:nzc+1, js:je, is:ie) )
-       p_3d => ptc
-    ELSEIF ( TRIM( name ) == "q")  THEN
-       IF ( .NOT. ALLOCATED( qc ) ) ALLOCATE( qc(0:nzc+1, js:je, is:ie) )
-       p_3d => qc
-    !ELSEIF (trim(name) == "z0") then
-       !IF (.not.allocated(z0c))  allocate(z0c(js:je, is:ie))
-       !p_2d => z0c
-    ENDIF
-
-    IF ( ASSOCIATED( p_3d ) )  THEN
-       CALL pmc_c_set_dataarray( p_3d )
-    ELSEIF ( ASSOCIATED( p_2d ) )  THEN
-       CALL pmc_c_set_dataarray( p_2d )
-    ELSE
-!
-!--    Give only one message for the first client domain
-       IF ( myid == 0  .AND.  cpl_id == 2 )  THEN
-
-          message_string = 'pointer for array "' // TRIM( name ) //            &
-                           '" can''t be associated'
-          CALL message( 'pmci_create_client_arrays', 'PA0170', 3, 2, 0, 6, 0 )
-       ELSE
-!
-!--       Avoid others to continue
-          CALL MPI_BARRIER( comm2d, ierr )
-       ENDIF
-    ENDIF
-
-#endif
- END SUBROUTINE pmci_create_client_arrays
-
-
-
- SUBROUTINE pmci_server_initialize
-
-#if defined( __parallel )
-    IMPLICIT NONE
-
-    INTEGER(iwp)   ::  client_id   !:
-    INTEGER(iwp)   ::  m           !:
-    REAL(wp)       ::  waittime    !:
-
-
-    DO  m = 1, SIZE( pmc_server_for_client ) - 1
-       client_id = pmc_server_for_client(m)
-       CALL pmc_s_fillbuffer( client_id, waittime=waittime )
-    ENDDO
-
-#endif
- END SUBROUTINE pmci_server_initialize
-
-
-
- SUBROUTINE pmci_client_initialize
-
-#if defined( __parallel )
-    IMPLICIT NONE
-
-    INTEGER(iwp)   ::  i          !:
-    INTEGER(iwp)   ::  icl        !:
-    INTEGER(iwp)   ::  icr        !:
-    INTEGER(iwp)   ::  j          !:
-    INTEGER(iwp)   ::  jcn        !:
-    INTEGER(iwp)   ::  jcs        !:
-    REAL(wp)       ::  waittime   !:
-
-
-    IF ( cpl_id > 1 )  THEN   !  Root id is never a client      
-
-!
-!--    Client domain boundaries in the server indice space.
-       icl = coarse_bound(1)
-       icr = coarse_bound(2)
-       jcs = coarse_bound(3)
-       jcn = coarse_bound(4)
-
-!
-!--    Get data from server      
-       CALL pmc_c_getbuffer( waittime = waittime )
-
-!
-!--    The interpolation.
-       CALL pmci_interp_tril_all ( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo, r2yo, r1zo, r2zo, nzb_u_inner, 'u' )
-       CALL pmci_interp_tril_all ( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv, r2yv, r1zo, r2zo, nzb_v_inner, 'v' )
-       CALL pmci_interp_tril_all ( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo, r2yo, r1zw, r2zw, nzb_w_inner, 'w' )
-       CALL pmci_interp_tril_all ( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo, nzb_s_inner, 'e' )
-       CALL pmci_interp_tril_all ( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo, nzb_s_inner, 's' )
-       IF ( humidity  .OR.  passive_scalar )  THEN
-          CALL pmci_interp_tril_all ( q, qc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo, nzb_s_inner, 's' )
-       ENDIF
-
-       IF ( topography /= 'flat' )  THEN
-
-!
-!--       Inside buildings set velocities and TKE back to zero.
-!--       Other scalars (pt, q, s, km, kh, p, sa, ...) are ignored at present,
-!--       maybe revise later.
-          DO   i = nxlg, nxrg
-             DO   j = nysg, nyng
-                u(nzb:nzb_u_inner(j,i),j,i)   = 0.0_wp
-                v(nzb:nzb_v_inner(j,i),j,i)   = 0.0_wp
-                w(nzb:nzb_w_inner(j,i),j,i)   = 0.0_wp
-                e(nzb:nzb_s_inner(j,i),j,i)   = 0.0_wp
-                u_p(nzb:nzb_u_inner(j,i),j,i) = 0.0_wp
-                v_p(nzb:nzb_v_inner(j,i),j,i) = 0.0_wp
-                w_p(nzb:nzb_w_inner(j,i),j,i) = 0.0_wp
-                e_p(nzb:nzb_s_inner(j,i),j,i) = 0.0_wp
-             ENDDO
-          ENDDO
-       ENDIF
-    ENDIF
-    
-
- CONTAINS
-
-
-   SUBROUTINE pmci_interp_tril_all( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y, r1z, r2z, kb, var )
-
-!
-!-- Interpolation of the internal values for the client-domain initialization.
-!-- This subroutine is based on trilinear interpolation.
-!-- Coding based on interp_tril_lr/sn/t
-!
-!--                                     Antti Hellsten 20.10.2015.
-      IMPLICIT NONE
-      REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) ::  f     !:
-      REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN)        ::  fc    !:
-      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)                        ::  r1x   !:
-      REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN)                        ::  r2x   !:
-      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)                        ::  r1y   !:
-      REAL(wp), DIMENSION(nysg:nyng), INTENT(IN)                        ::  r2y   !:
-      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)                        ::  r1z   !:
-      REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN)                        ::  r2z   !:
-      INTEGER(iwp), DIMENSION(nxlg:nxrg), INTENT(IN)                    ::  ic    !:
-      INTEGER(iwp), DIMENSION(nysg:nyng), INTENT(IN)                    ::  jc    !:
-      INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)                    ::  kc    !: 
-      INTEGER(iwp), DIMENSION(nysg:nyng,nxlg:nxrg), INTENT(IN)          ::  kb    !:
-      CHARACTER(LEN=1), INTENT(IN) :: var  !:
-      
-      INTEGER(iwp) ::  i      !:
-      INTEGER(iwp) ::  ib     !:
-      INTEGER(iwp) ::  ie     !:
-      INTEGER(iwp) ::  j      !:
-      INTEGER(iwp) ::  jb     !:
-      INTEGER(iwp) ::  je     !:
-      INTEGER(iwp) ::  k      !:
-      INTEGER(iwp) ::  k1     !:
-      INTEGER(iwp) ::  kbc    !:
-      INTEGER(iwp) ::  l      !:
-      INTEGER(iwp) ::  m      !:
-      INTEGER(iwp) ::  n      !:
-      REAL(wp) ::  fk         !:
-      REAL(wp) ::  fkj        !:
-      REAL(wp) ::  fkjp       !:
-      REAL(wp) ::  fkp        !:
-      REAL(wp) ::  fkpj       !:
-      REAL(wp) ::  fkpjp      !:
-      REAL(wp) ::  logratio   !:
-      REAL(wp) ::  logzuc1    !:
-      REAL(wp) ::  zuc1       !:
-      
-      
-      ib = nxl
-      ie = nxr
-      jb = nys   
-      je = nyn
-      IF ( nest_bound_l )  THEN
-         ib = nxl - 1 
-         IF ( var == 'u' )  THEN   !  For u, nxl is a ghost node, but not for the other variables.
-            ib = nxl
-         ENDIF
-      ENDIF
-      IF ( nest_bound_s )  THEN
-         jb = nys - 1 
-         IF ( var == 'v' )  THEN   !  For v, nys is a ghost node, but not for the other variables.
-            jb = nys
-         ENDIF
-      ENDIF
-      IF ( nest_bound_r )  THEN
-         ie = nxr + 1
-      ENDIF
-      IF ( nest_bound_n )  THEN
-         je = nyn + 1
-      ENDIF
-
-!
-!--   Trilinear interpolation.
-      DO  i = ib, ie
-         DO  j = jb, je
-            DO  k = kb(j,i), nzt + 1 
-               l = ic(i)
-               m = jc(j)
-               n = kc(k)
-               fkj      = r1x(i) * fc(n,m,l)     + r2x(i) * fc(n,m,l+1)
-               fkjp     = r1x(i) * fc(n,m+1,l)   + r2x(i) * fc(n,m+1,l+1)
-               fkpj     = r1x(i) * fc(n+1,m,l)   + r2x(i) * fc(n+1,m,l+1)
-               fkpjp    = r1x(i) * fc(n+1,m+1,l) + r2x(i) * fc(n+1,m+1,l+1)
-               fk       = r1y(j) * fkj  + r2y(j) * fkjp
-               fkp      = r1y(j) * fkpj + r2y(j) * fkpjp
-               f(k,j,i) = r1z(k) * fk   + r2z(k) * fkp
-            ENDDO
-         ENDDO
-      ENDDO
-
-!
-!--   Correct the interpolated values of u and v in near-wall nodes, i.e. in 
-!--   the nodes below the coarse-grid nodes with k=1. The corrction is only made 
-!--   over horizontal wall surfaces in this phase. For the nest boundary conditions,
-!--   a corresponding corrections is made for all vertical walls, too. 
-      IF ( var == 'u' .OR. var == 'v' )  THEN
-         DO  i = ib, nxr
-            DO  j = jb, nyn              
-               kbc = 1
-               DO  WHILE ( cg%zu(kbc) < zu(kb(j,i)) )   !  kbc is the first coarse-grid point above the surface.
-                  kbc = kbc + 1
-               ENDDO
-               zuc1    = cg%zu(kbc)
-               k1      = kb(j,i) + 1  
-               DO  WHILE ( zu(k1) < zuc1 )
-                  k1 = k1 + 1
-               ENDDO
-               logzuc1 = LOG( ( zu(k1) - zu(kb(j,i)) ) / z0(j,i) )
-               
-               k = kb(j,i) + 1
-               DO  WHILE ( zu(k) < zuc1 ) 
-                  logratio = ( LOG( ( zu(k) - zu(kb(j,i)) ) / z0(j,i)) ) / logzuc1 
-                  f(k,j,i) = logratio * f(k1,j,i)
-                  k  = k + 1
-               ENDDO
-               f(kb(j,i),j,i) = 0.0_wp
-            ENDDO
-         ENDDO
-      ELSEIF ( var == 'w' )  THEN
-         DO  i = ib, nxr
-            DO  j = jb, nyn
-               f(kb(j,i),j,i) = 0.0_wp
-            ENDDO
-         ENDDO
-      ENDIF
-      
-   END SUBROUTINE pmci_interp_tril_all
-
-#endif
- END SUBROUTINE pmci_client_initialize
-
-
-
- SUBROUTINE pmci_ensure_nest_mass_conservation
-
-#if defined( __parallel )
-!
-!-- Adjust the volume-flow rate through the top boundary 
-!-- so that the net volume flow through all boundaries 
-!-- of the current nest domain becomes zero.
-    IMPLICIT NONE
-
-    INTEGER(iwp)  ::  i                          !:
-    INTEGER(iwp)  ::  ierr                       !:
-    INTEGER(iwp)  ::  j                          !:
-    INTEGER(iwp)  ::  k                          !:
-    REAL(wp) ::  dxdy                            !:
-    REAL(wp) ::  innor                           !:
-    REAL(wp), DIMENSION(1:3) ::  volume_flow_l   !:
-    REAL(wp) ::  w_lt                            !:
-
-!
-!-- Sum up the volume flow through the left/right boundaries.
-    volume_flow(1)   = 0.0_wp
-    volume_flow_l(1) = 0.0_wp
-
-    IF ( nest_bound_l )  THEN
-       i = 0 
-       innor = dy
-       DO   j = nys, nyn
-          DO   k = nzb_u_inner(j,i) + 1, nzt
-             volume_flow_l(1) = volume_flow_l(1) + innor * u(k,j,i) * dzw(k)            
-          ENDDO
-       ENDDO
-    ENDIF
-
-    IF ( nest_bound_r )  THEN     
-       i = nx + 1
-       innor = -dy
-       DO   j = nys, nyn
-          DO   k = nzb_u_inner(j,i) + 1, nzt
-             volume_flow_l(1) = volume_flow_l(1) + innor * u(k,j,i) * dzw(k)            
-          ENDDO
-       ENDDO
-    ENDIF
-      
-#if defined( __parallel )   
-    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( volume_flow_l(1), volume_flow(1), 1, MPI_REAL, &
-                        MPI_SUM, comm2d, ierr )
-#else
-    volume_flow(1) = volume_flow_l(1)
-#endif
-
-!
-!-- Sum up the volume flow through the south/north boundaries.
-    volume_flow(2)   = 0.0_wp
-    volume_flow_l(2) = 0.0_wp
-
-    IF ( nest_bound_s )  THEN
-       j = 0
-       innor = dx
-       DO   i = nxl, nxr
-          DO   k = nzb_v_inner(j,i) + 1, nzt
-             volume_flow_l(2) = volume_flow_l(2) + innor * v(k,j,i) * dzw(k)
-          ENDDO
-       ENDDO
-    ENDIF
-
-    IF ( nest_bound_n )  THEN
-       j = ny + 1
-       innor = -dx
-       DO   i = nxl, nxr
-          DO   k = nzb_v_inner(j,i)+1, nzt
-             volume_flow_l(2) = volume_flow_l(2) + innor * v(k,j,i) * dzw(k)
-          ENDDO
-       ENDDO
-    ENDIF
-
-#if defined( __parallel )   
-    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( volume_flow_l(2), volume_flow(2), 1, MPI_REAL, &
-                        MPI_SUM, comm2d, ierr )   
-#else
-    volume_flow(2) = volume_flow_l(2)
-#endif
-      
-!
-!-- Sum up the volume flow through the top boundary.
-    volume_flow(3)   = 0.0_wp
-    volume_flow_l(3) = 0.0_wp
-    dxdy = dx * dy
-    k = nzt 
-    DO   i = nxl, nxr
-       DO   j = nys, nyn
-          volume_flow_l(3) = volume_flow_l(3) - w(k,j,i) * dxdy
-       ENDDO
-    ENDDO
-       
-#if defined( __parallel )   
-    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( volume_flow_l(3), volume_flow(3), 1, MPI_REAL, &
-                        MPI_SUM, comm2d, ierr )   
-#else
-    volume_flow(3) = volume_flow_l(3)
-#endif
-
-!
-!-- Correct the top-boundary value of w.
-    w_lt = (volume_flow(1) + volume_flow(2) + volume_flow(3)) / area_t
-    DO   i = nxl, nxr
-       DO   j = nys, nyn
-          DO  k = nzt, nzt + 1
-             w(k,j,i) = w(k,j,i) + w_lt
-          ENDDO
-       ENDDO
-    ENDDO
-
-#endif
- END SUBROUTINE pmci_ensure_nest_mass_conservation
-
 END MODULE pmc_interface
